

(Adapted from Pearl [<a class="paperRef" title="" href="">Pearl:1988</a>].) A used-car
buyer can decide to carry out various tests with various costs (e.g.,
kick the tires, take the car to a qualified mechanic) and then,
depending on the outcome of the tests, decide which car to buy. We will
assume that the buyer is deciding whether to buy car $c_1$, that there
is time to carry out at most one test, and that $t_1$ is the test of
$c_1$ and costs \$50.<br>

A car can be in good shape (quality $q^+$) or bad shape (quality $q^-$),
and the tests might help indicate what shape the car is in. Car $c_1$
costs \$1,500, and its market value is $\$2,000$ if it is in good shape; if
not, $\$700$ in repairs will be needed to make it in good shape. The buyer’s
estimate is that $c_1$ has a 70% chance of being in good shape.<br>

1.  Draw the decision network that represents this problem.<br>

2.  Calculate the expected net gain from buying $c_1$, given no test.<br>

3.  Tests can be described by the probability that the car will pass or
    fail the test given that the car is in good or bad shape. We have
    the following information:<br>

    $P({pass}(c_1,t_1) | q^+(c_1)) = {0.8}$<br>

    $P({pass}(c_1,t_1) | q^-(c_1)) = {0.35}$<br>

    Use Bayes’ theorem to calculate the probability that the car will pass (or fail) its test and hence the probability that it is in good (or bad) shape given each possible test outcome.<br>

4.  Calculate the optimal decisions given either a pass or a fail, and
    their expected utilities.<br>

5.  Calculate the value of information of the test, and derive an
    optimal conditional plan for the buyer.<br>
