

This exercise explores the relationship between
workspace and configuration space using the examples shown in
Figure <a class="insideExercisesFigRef"  href="#FigEx2">FigEx2</a>.

1.  Consider the robot configurations shown in
    Figure <a class="insideExercisesFigRef"  href="#FigEx2">FigEx2</a>(a) through (c), ignoring the obstacle
    shown in each of the diagrams. Draw the corresponding arm
    configurations in configuration space. (<i>Hint:</i> Each
    arm configuration maps to a single point in configuration space, as
    illustrated in Figure <a class="insideExercisesFigRef"  href="#FigEx2">FigArm1</a>(b).)<br>

2.  Draw the configuration space for each of the workspace diagrams in
    Figure <a class="insideExercisesFigRef"  href="#FigEx2">FigEx2</a>(a)–(c). (<i>Hint:</i> The
    configuration spaces share with the one shown in
    Figure <a class="insideExercisesFigRef"  href="#FigEx2">FigEx2</a>(a) the region that corresponds to
    self-collision, but differences arise from the lack of enclosing
    obstacles and the different locations of the obstacles in these
    individual figures.)<br>

3.  For each of the black dots in Figure <a href="#">FigEx2</a>(e)–(f),
    draw the corresponding configurations of the robot arm in workspace.
    Please ignore the shaded regions in this exercise.<br>

4.  The configuration spaces shown in
    Figure <a class="insideExercisesFigRef"  href="#FigEx2">FigEx2</a>(e)–(f) have all been generated by a
    single workspace obstacle (dark shading), plus the constraints
    arising from the self-collision constraint (light shading). Draw,
    for each diagram, the workspace obstacle that corresponds to the
    darkly shaded area.<br>

5.  Figure <a class="insideExercisesFigRef"  href="#FigEx2">FigEx2</a>(d) illustrates that a single planar
    obstacle can decompose the workspace into two disconnected regions.
    What is the maximum number of disconnected regions that can be
    created by inserting a planar obstacle into an obstacle-free,
    connected workspace, for a 2DOF robot? Give an example, and argue
    why no larger number of disconnected regions can be created. How
    about a non-planar obstacle?<br>

    <figure>
      <img src="https://aimacode.github.io/aima-exercises/figures/exerciseRobot1.svg" alt="FigEx2" id="FigEx2" style="width:100%">
      <figcaption><center><b>(a)</b></center></figcaption>
    </figure>
    <figure>
      <img src="https://aimacode.github.io/aima-exercises/figures/exerciseRobot3.svg" alt="FigEx2" id="FigEx2" style="width:100%">
      <figcaption><center><b>(b)</b></center></figcaption>
    </figure>
    <figure>
      <img src="https://aimacode.github.io/aima-exercises/figures/exerciseRobot6.svg" alt="FigEx2" id="FigEx2" style="width:100%">
      <figcaption><center><b>(c)</b></center></figcaption>
    </figure>
    <figure>
      <img src="https://aimacode.github.io/aima-exercises/figures/exerciseConf2.svg" alt="FigEx2" id="FigEx2" style="width:100%">
      <figcaption><center><b>(d)</b></center></figcaption>
    </figure>
    <figure>
      <img src="https://aimacode.github.io/aima-exercises/figures/exerciseConf4.svg" alt="FigEx2" id="FigEx2" style="width:100%">
      <figcaption><center><b>(e)</b></center></figcaption>
    </figure>
    <figure>
      <img src="https://aimacode.github.io/aima-exercises/figures/exerciseConf5.svg" alt="FigEx2" id="FigEx2" style="width:100%">
      <figcaption><center><b>(f)</b></center></figcaption>
    </figure>
