---
layout: chapter
title: Introduction
permalink: /intro-exercises/
chapterLabel: 1-Introduction
breadcrumb: Introduction
---

{% include mathjax_support %}

# 1. Introduction

These exercises are intended to stimulate discussion, and some might be
set as term projects. Alternatively, preliminary attempts can be made
now, and these attempts can be reviewed after the completion of the
book.
<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_1/' class="p-2">Exercise 1</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex1');" href="#"><i id="ch1ex1" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ch1ex1');" href="#"><i id="ch1ex1" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_1/question.md %}</p>
    </div>
</div>

<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_2/' class="p-2">Exercise 2</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex2');" href="#"><i id="ch1ex2" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ch1ex2');" href="#"><i id="ch1ex2" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_2/question.md %}</p>
    </div>
</div>

<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_3/' class="p-2">Exercise 3</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex3');" href="#"><i id="ch1ex3" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex1.3');" href="#"><i id="ch1ex3" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_3/question.md %}</p>
    </div>
</div>

<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_4/' class="p-2">Exercise 4</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex1');" href="#"><i id="ch1ex4" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex1.4');" href="#"><i id="ch1ex4" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_4/question.md %}</p>
    </div>
</div>

<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_5/' class="p-2">Exercise 5</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex5');" href="#"><i id="ch1ex5" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex1.5');" href="#"><i id="ch1ex5" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_5/question.md %}</p>
    </div>
</div>

<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_6/' class="p-2">Exercise 6</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex6');" href="#"><i id="ch1ex6" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex1.6');" href="#"><i id="ch1ex6" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_6/question.md %}</p>
    </div>
</div>

<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_7/' class="p-2">Exercise 7</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex7');" href="#"><i id="ch1ex7" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex1.7');" href="#"><i id="ch1ex7" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_7/question.md %}</p>
    </div>
</div>

<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_8/' class="p-2">Exercise 8</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex8');" href="#"><i id="ch1ex8" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex1.8');" href="#"><i id="ch1ex8" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_8/question.md %}</p>
    </div>
</div>

<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_9/' class="p-2">Exercise 9</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex1');" href="#"><i id="ch1ex9" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex1.9');" href="#"><i id="ch1ex9" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_9/question.md %}</p>
    </div>
</div>

<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_10/' class="p-2">Exercise 10</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex10');" href="#"><i id="ch1ex10" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex1.10');" href="#"><i id="ch1ex10" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_10/question.md %}</p>
    </div>
</div>

<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_11/' class="p-2">Exercise 11</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex11');" href="#"><i id="ch1ex11" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex1.11');" href="#"><i id="ch1ex11" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_11/question.md %}</p>
    </div>
</div>

<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_12/' class="p-2">Exercise 12</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex12');" href="#"><i id="ch1ex12" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex1.12');" href="#"><i id="ch1ex12" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_12/question.md %}</p>
    </div>
</div>

<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_13/' class="p-2">Exercise 13</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex13');" href="#"><i id="ch1ex13" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex1.13');" href="#"><i id="ch1ex1" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_13/question.md %}</p>
    </div>
</div>

<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_14/' class="p-2">Exercise 14</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex14');" href="#"><i id="ch1ex14" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex1.14');" href="#"><i id="ch1ex14" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_14/question.md %}</p>
    </div>
</div>

<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_15/' class="p-2">Exercise 15</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex1');" href="#"><i id="ch1ex15" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex1.15');" href="#"><i id="ch1ex15" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_15/question.md %}</p>
    </div>
</div>

<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_16/' class="p-2">Exercise 16</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex16');" href="#"><i id="ch1ex16" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex1.16');" href="#"><i id="ch1ex16" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_16/question.md %}</p>
    </div>
</div>

<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_17/' class="p-2">Exercise 17</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex17');" href="#"><i id="ch1ex17" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex1.17');" href="#"><i id="ch1ex17" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_17/question.md %}</p>
    </div>
</div>

<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_18/' class="p-2">Exercise 18</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex18');" href="#"><i id="ch1ex18" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex1.18');" href="#"><i id="ch1ex18" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_18/question.md %}</p>
    </div>
</div>

<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_19/' class="p-2">Exercise 19</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex19');" href="#"><i id="ch1ex19" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex1.19');" href="#"><i id="ch1ex19" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_19/question.md %}</p>
    </div>
</div>

<br>
<div class="card">
    <div class="card-header p-2">
        <a href='ex_20/' class="p-2">Exercise 20</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch1ex20');" href="#"><i id="ch1ex20" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex1.20');" href="#"><i id="ch1ex20" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_20/question.md %}</p>
    </div>
</div>

<br>


