---
layout: chapter
title: Probabilistic Reasoning over time
permalink: /dbn-exercises/
---

{% include mathjax_support %}

# 15. Probabilistic Reasoning over Time

<div class="card">
<div class="card-header p-2">
<a href='ex_1/' class="p-2">Exercise 1 (state-augmentation-exercise)</a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex1');" href="#"><i id="ch15ex1" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.1);" href="#"><i id="ch15ex1" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_1/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_2/' class="p-2">Exercise 2 (markov-convergence-exercise) </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex2');" href="#"><i id="ch15ex2" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.2);" href="#"><i id="ch15ex2" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_2/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_3/' class="p-2">Exercise 3 (island-exercise) </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex3');" href="#"><i id="ch15ex3" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.3);" href="#"><i id="ch15ex3" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_3/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_4/' class="p-2">Exercise 4 (flawed-viterbi-exercise) </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex4');" href="#"><i id="ch15ex4" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.4);" href="#"><i id="ch15ex4" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_4/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_5/' class="p-2">Exercise 5 (hmm-likelihood-exercise) </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex5');" href="#"><i id="ch15ex5" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.5);" href="#"><i id="ch15ex5" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_5/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_6/' class="p-2">Exercise 6 </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex6');" href="#"><i id="ch15ex6" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.6);" href="#"><i id="ch15ex6" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_6/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_7/' class="p-2">Exercise 7 (hmm-robust-exercise) </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex7');" href="#"><i id="ch15ex7" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.7);" href="#"><i id="ch15ex7" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_7/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_8/' class="p-2">Exercise 8 (roomba-viterbi-exercise)</a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex8');" href="#"><i id="ch15ex8" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.8);" href="#"><i id="ch15ex8" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_8/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_9/' class="p-2">Exercise 9 </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex9');" href="#"><i id="ch15ex9" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.9);" href="#"><i id="ch15ex9" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_9/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_10/' class="p-2">Exercise 10 </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex10');" href="#"><i id="ch15ex10" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.10);" href="#"><i id="ch15ex10" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_10/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_11/' class="p-2">Exercise 11 </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex11');" href="#"><i id="ch15ex11" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.11);" href="#"><i id="ch15ex11" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_11/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_12/' class="p-2">Exercise 12 (switching-kf-exercise) </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex12');" href="#"><i id="ch15ex12" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.12);" href="#"><i id="ch15ex12" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_12/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_13/' class="p-2">Exercise 13 (kalman-update-exercise) </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex13');" href="#"><i id="ch15ex13" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.13);" href="#"><i id="ch15ex13" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_13/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_14/' class="p-2">Exercise 14 (kalman-variance-exercise)</a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex14');" href="#"><i id="ch15ex14" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.14);" href="#"><i id="ch15ex14" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_14/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_15/' class="p-2">Exercise 15 (sleep1-exercise) </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex15');" href="#"><i id="ch15ex15" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.15);" href="#"><i id="ch15ex15" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_15/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_16/' class="p-2">Exercise 16 </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex16');" href="#"><i id="ch15ex16" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.16);" href="#"><i id="ch15ex16" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_16/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_17/' class="p-2">Exercise 17 </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex17');" href="#"><i id="ch15ex17" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.17);" href="#"><i id="ch15ex17" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_17/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_18/' class="p-2">Exercise 18 </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex18');" href="#"><i id="ch15ex18" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.18);" href="#"><i id="ch15ex18" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_18/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_19/' class="p-2">Exercise 19 (battery-sequence-exercise) </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex19');" href="#"><i id="ch15ex19" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.19);" href="#"><i id="ch15ex19" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_19/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_20/' class="p-2">Exercise 20 (dbn-elimination-exercise) </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch15ex20');" href="#"><i id="ch15ex20" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex15.20);" href="#"><i id="ch15ex20" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_20/question.md %}</p>
</div>
</div>
<br>
