

(Adapted from David Heckerman.) This exercise concerns
the <b>Almanac Game</b>, which is used by
decision analysts to calibrate numeric estimation. For each of the
questions that follow, give your best guess of the answer, that is, a
number that you think is as likely to be too high as it is to be too
low. Also give your guess at a 25th percentile estimate, that is, a
number that you think has a 25% chance of being too high, and a 75%
chance of being too low. Do the same for the 75th percentile. (Thus, you
should give three estimates in all—low, median, and high—for each
question.)<br>

1.  Number of passengers who flew between New York and Los Angeles
    in 1989.<br>

2.  Population of Warsaw in 1992.<br>

3.  Year in which Coronado discovered the Mississippi River.<br>

4.  Number of votes received by Jimmy Carter in the 1976
    presidential election.<br>

5.  Age of the oldest living tree, as of 2002.<br>

6.  Height of the Hoover Dam in feet.<br>

7.  Number of eggs produced in Oregon in 1985.<br>

8.  Number of Buddhists in the world in 1992.<br>

9.  Number of deaths due to AIDS in the United States
    in 1981.<br>

10. Number of U.S. patents granted in 1901.<br>

The correct answers appear after the last exercise of this chapter. From
the point of view of decision analysis, the interesting thing is not how
close your median guesses came to the real answers, but rather how often
the real answer came within your 25% and 75% bounds. If it was about
half the time, then your bounds are accurate. But if you’re like most
people, you will be more sure of yourself than you should be, and fewer
than half the answers will fall within the bounds. With practice, you
can calibrate yourself to give realistic bounds, and thus be more useful
in supplying information for decision making. Try this second set of
questions and see if there is any improvement:<br>

1.  Year of birth of Zsa Zsa Gabor.<br>

2.  Maximum distance from Mars to the sun in miles.<br>

3.  Value in dollars of exports of wheat from the United States in 1992.<br>

4.  Tons handled by the port of Honolulu in 1991.<br>

5.  Annual salary in dollars of the governor of California in 1993.<br>

6.  Population of San Diego in 1990.<br>

7.  Year in which Roger Williams founded Providence, Rhode Island.<br>

8.  Height of Mt. Kilimanjaro in feet.<br>

9.  Length of the Brooklyn Bridge in feet.<br>

10. Number of deaths due to automobile accidents in the United States
    in 1992.<br>
