---
layout: chapter
title: Learning Probabilistic Models
permalink: /bayesian-learning-exercises/
---

{% include mathjax_support %}

# 20. Learning Probabilistic Models

<div class="card">
<div class="card-header p-2">
<a href='ex_1/' class="p-2">Exercise 1 (bayes-candy-exercise) </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch20ex1');" href="#"><i id="ch20ex1" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex20.1);" href="#"><i id="ch20ex1" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_1/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_2/' class="p-2">Exercise 2 </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch20ex2');" href="#"><i id="ch20ex2" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex20.2);" href="#"><i id="ch20ex2" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_2/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_3/' class="p-2">Exercise 3 (candy-trade-exercise) </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch20ex3');" href="#"><i id="ch20ex3" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex20.3);" href="#"><i id="ch20ex3" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_3/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_4/' class="p-2">Exercise 4 </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch20ex4');" href="#"><i id="ch20ex4" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex20.4);" href="#"><i id="ch20ex4" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_4/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_5/' class="p-2">Exercise 5 (BNB-exercise) </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch20ex5');" href="#"><i id="ch20ex5" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex20.5);" href="#"><i id="ch20ex5" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_5/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_6/' class="p-2">Exercise 6 (linear-regression-exercise) </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch20ex6');" href="#"><i id="ch20ex6" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex20.6);" href="#"><i id="ch20ex6" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_6/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_7/' class="p-2">Exercise 7 (noisy-OR-ML-exercise) </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch20ex7');" href="#"><i id="ch20ex7" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex20.7);" href="#"><i id="ch20ex7" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_7/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_8/' class="p-2">Exercise 8 (beta-integration-exercise) </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch20ex8');" href="#"><i id="ch20ex8" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex20.8);" href="#"><i id="ch20ex8" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_8/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_9/' class="p-2">Exercise 9 (ML-parents-exercise) </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch20ex9');" href="#"><i id="ch20ex9" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex20.9);" href="#"><i id="ch20ex9" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_9/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_10/' class="p-2">Exercise 10 </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch20ex10');" href="#"><i id="ch20ex10" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex20.10);" href="#"><i id="ch20ex10" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_10/question.md %}</p>
</div>
</div>
<br>
<div class="card">
<div class="card-header p-2">
<a href='ex_11/' class="p-2">Exercise 11 </a>
<button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch20ex11');" href="#"><i id="ch20ex11" class="fas fa-bookmark" style="color:white"></i></button>
<button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex20.11);" href="#"><i id="ch20ex11" class="fas fa-thumbs-up" style="color:white"></i></button>
</div>
<div class="card-body">
<p class="card-text">{% include_relative exercises/ex_11/question.md %}</p>
</div>
</div>
<br>
