---
layout: chapter
title: Constraint Satisfaction Problems
permalink: /csp-exercises/
---

{% include mathjax_support %}

# 6. Constraint Satisfaction Problems

<div class="card">
    <div class="card-header p-2">
        <a href='ex_1/' class="p-2">Exercise 1 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex1');" href="#"><i id="ch6ex1" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.1');" href="#"><i id="ch6ex1" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_1/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_2/' class="p-2">Exercise 2 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex2');" href="#"><i id="ch6ex2" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.2');" href="#"><i id="ch6ex2" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_2/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_3/' class="p-2">Exercise 3 (crossword-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex3');" href="#"><i id="ch6ex3" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.3');" href="#"><i id="ch6ex3" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_3/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_4/' class="p-2">Exercise 4 (csp-definition-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex4');" href="#"><i id="ch6ex4" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.4');" href="#"><i id="ch6ex4" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_4/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_5/' class="p-2">Exercise 5 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex5');" href="#"><i id="ch6ex5" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.5');" href="#"><i id="ch6ex5" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_5/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_6/' class="p-2">Exercise 6 (nary-csp-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex6');" href="#"><i id="ch6ex6" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.6');" href="#"><i id="ch6ex6" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_6/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_7/' class="p-2">Exercise 7 (zebra-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex7');" href="#"><i id="ch6ex7" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.7');" href="#"><i id="ch6ex7" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_7/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_8/' class="p-2">Exercise 8 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex8');" href="#"><i id="ch6ex8" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.8');" href="#"><i id="ch6ex8" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_8/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_9/' class="p-2">Exercise 9 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex9');" href="#"><i id="ch6ex9" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.9');" href="#"><i id="ch6ex9" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_9/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_10/' class="p-2">Exercise 10 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex10');" href="#"><i id="ch6ex10" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.10');" href="#"><i id="ch6ex10" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_10/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_11/' class="p-2">Exercise 11 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex11');" href="#"><i id="ch6ex11" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.11');" href="#"><i id="ch6ex11" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_11/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_12/' class="p-2">Exercise 12 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex12');" href="#"><i id="ch6ex12" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.12');" href="#"><i id="ch6ex12" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_12/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_13/' class="p-2">Exercise 13 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex13');" href="#"><i id="ch6ex13" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.13');" href="#"><i id="ch6ex13" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_13/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex14/' class="p-2">Exercise 14 (ac4-exercise)</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex14');" href="#"><i id="ch6ex14" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.14');" href="#"><i id="ch6ex14" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_14/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex15/' class="p-2">Exercise 15 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex15');" href="#"><i id="ch6ex15" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.15');" href="#"><i id="ch6ex15" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_15/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex16/' class="p-2">Exercise 16 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex16');" href="#"><i id="ch6ex16" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.14');" href="#"><i id="ch6ex16" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_16/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex17/' class="p-2">Exercise 17 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex17');" href="#"><i id="ch6ex17" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.17');" href="#"><i id="ch6ex17" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_17/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex18/' class="p-2">Exercise 18 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex18');" href="#"><i id="ch6ex18" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.18');" href="#"><i id="ch6ex18" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_18/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex19/' class="p-2">Exercise 19 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex19');" href="#"><i id="ch6ex19" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.19');" href="#"><i id="ch6ex19" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_19/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex20/' class="p-2">Exercise 20 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch6ex20');" href="#"><i id="ch6ex20" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex6.20');" href="#"><i id="ch6ex20" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_20/question.md %}</p>
    </div>
</div>

<br>
<div id="footnote1">^1. @Ginsberg+al:1990 discuss several methods for constructing crossword puzzles.
@Littman+al:1999 tackle the harder problem of solving them.</div>

