---
layout: chapter
title: Logical Agents
permalink: /knowledge-logic-exercises/
---

{% include mathjax_support %}

# 7. Logical Agents

<div class="card">
    <div class="card-header p-2">
        <a href='ex_1/' class="p-2">Exercise 1 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex1');" href="#"><i id="ch7ex1" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.1');" href="#"><i id="ch7ex1" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_1/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_2/' class="p-2">Exercise 2 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex2');" href="#"><i id="ch7ex2" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.2');" href="#"><i id="ch7ex2" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_2/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_3/' class="p-2">Exercise 3 (truth-value-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex3');" href="#"><i id="ch7ex3" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.3');" href="#"><i id="ch7ex3" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_3/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_4/' class="p-2">Exercise 4 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex4');" href="#"><i id="ch7ex4" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.4');" href="#"><i id="ch7ex4" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_4/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_5/' class="p-2">Exercise 5 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex5');" href="#"><i id="ch7ex5" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.5');" href="#"><i id="ch7ex5" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_5/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_6/' class="p-2">Exercise 6 (deduction-theorem-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex6');" href="#"><i id="ch7ex6" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.6');" href="#"><i id="ch7ex6" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_6/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_7/' class="p-2">Exercise 7 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex7');" href="#"><i id="ch7ex7" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.7');" href="#"><i id="ch7ex7" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_7/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_8/' class="p-2">Exercise 8 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex8');" href="#"><i id="ch7ex8" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.8');" href="#"><i id="ch7ex8" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_8/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_9/' class="p-2">Exercise 9 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex9');" href="#"><i id="ch7ex9" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.9');" href="#"><i id="ch7ex9" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_9/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_10/' class="p-2">Exercise 10 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex10');" href="#"><i id="ch7ex10" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.10');" href="#"><i id="ch7ex10" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_10/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_11/' class="p-2">Exercise 11 (logical-equivalence-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex11');" href="#"><i id="ch7ex11" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.11');" href="#"><i id="ch7ex11" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_11/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_12/' class="p-2">Exercise 12 (propositional-validity-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex12');" href="#"><i id="ch7ex12" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.12');" href="#"><i id="ch7ex12" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_12/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_13/' class="p-2">Exercise 13 (propositional-validity-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex13');" href="#"><i id="ch7ex13" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.13');" href="#"><i id="ch7ex13" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_13/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_14/' class="p-2">Exercise 14 (cnf-proof-exercise)</a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex14');" href="#"><i id="ch7ex14" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.14');" href="#"><i id="ch7ex14" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_14/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_15/' class="p-2">Exercise 15 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex15');" href="#"><i id="ch7ex15" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.15');" href="#"><i id="ch7ex15" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_15/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_16/' class="p-2">Exercise 16 (inf-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex16');" href="#"><i id="ch7ex16" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.16');" href="#"><i id="ch7ex16" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_16/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_17/' class="p-2">Exercise 17 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex17');" href="#"><i id="ch7ex17" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.17');" href="#"><i id="ch7ex17" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_17/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_18/' class="p-2">Exercise 18 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex18');" href="#"><i id="ch7ex18" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.18');" href="#"><i id="ch7ex18" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_18/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_19/' class="p-2">Exercise 19 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex19');" href="#"><i id="ch7ex19" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.19');" href="#"><i id="ch7ex19" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_19/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_20/' class="p-2">Exercise 20 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex20');" href="#"><i id="ch7ex20" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.20');" href="#"><i id="ch7ex20" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_20/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_21/' class="p-2">Exercise 21 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex21');" href="#"><i id="ch7ex21" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.21');" href="#"><i id="ch7ex21" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_21/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_22/' class="p-2">Exercise 22 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex22');" href="#"><i id="ch7ex22" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.2');" href="#"><i id="ch7ex22" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_22/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_23/' class="p-2">Exercise 23 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex23');" href="#"><i id="ch7ex23" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.23');" href="#"><i id="ch7ex23" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_23/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_24/' class="p-2">Exercise 24 (dnf-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex24');" href="#"><i id="ch7ex24" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.24');" href="#"><i id="ch7ex24" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_24/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_25/' class="p-2">Exercise 25 (convert-clausal-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex25');" href="#"><i id="ch7ex25" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.25');" href="#"><i id="ch7ex25" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_25/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_2/' class="p-2">Exercise 26 (convert-clausal-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex26');" href="#"><i id="ch7ex26" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.26');" href="#"><i id="ch7ex26" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_26/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_27/' class="p-2">Exercise 27 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex27');" href="#"><i id="ch7ex27" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.27');" href="#"><i id="ch7ex27" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_27/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_28/' class="p-2">Exercise 28 (minesweeper-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex28');" href="#"><i id="ch7ex28" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.28');" href="#"><i id="ch7ex28" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_28/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_29/' class="p-2">Exercise 29 (known-literal-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex29');" href="#"><i id="ch7ex29" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.29');" href="#"><i id="ch7ex29" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_29/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_30/' class="p-2">Exercise 30 (dpll-fc-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex30');" href="#"><i id="ch7ex30" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.30');" href="#"><i id="ch7ex30" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_30/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_31/' class="p-2">Exercise 31 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex31');" href="#"><i id="ch7ex31" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.31');" href="#"><i id="ch7ex31" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_31/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_32/' class="p-2">Exercise 32 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex32');" href="#"><i id="ch7ex32" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.32');" href="#"><i id="ch7ex32" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_32/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_3/' class="p-2">Exercise 33  </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex33');" href="#"><i id="ch7ex33" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.33');" href="#"><i id="ch7ex33" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_33/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_34/' class="p-2">Exercise 34 (ss-axiom-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex34');" href="#"><i id="ch7ex34" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.34');" href="#"><i id="ch7ex34" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_34/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_35/' class="p-2">Exercise 35 (hybrid-wumpus-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark Exercise" onclick="bookmark('ch7ex35');" href="#"><i id="ch7ex35" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex7.35');" href="#"><i id="ch7ex35" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_35/question.md %}</p>
    </div>
</div>

<br>
