---
layout: chapter
title: Inference in First Order Logic
permalink: /logical-inference-exercises/
---

{% include mathjax_support %}

# 9. Inference in First-Order Logic

<div class="card">
    <div class="card-header p-2">
        <a href='ex_1/' class="p-2">Exercise 1 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex1');" href="#"><i id="ch9ex1" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.1');" href="#"><i id="ch9ex1" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_1/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_2/' class="p-2">Exercise 2 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex2');" href="#"><i id="ch9ex2" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.2');" href="#"><i id="ch9ex2" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_2/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_3/' class="p-2">Exercise 3 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex3');" href="#"><i id="ch9ex3" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.3');" href="#"><i id="ch9ex3" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_3/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_4/' class="p-2">Exercise 4 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex4');" href="#"><i id="ch9ex4" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.4');" href="#"><i id="ch9ex4" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_4/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_5/' class="p-2">Exercise 5 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex5');" href="#"><i id="ch9ex5" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.5');" href="#"><i id="ch9ex5" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_5/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_6/' class="p-2">Exercise 6 (subsumption-lattice-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex6');" href="#"><i id="ch9ex6" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.6');" href="#"><i id="ch9ex6" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_6/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_7/' class="p-2">Exercise 7 (fol-horses-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex7');" href="#"><i id="ch9ex7" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.7');" href="#"><i id="ch9ex7" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_7/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_8/' class="p-2">Exercise 8 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex8');" href="#"><i id="ch9ex8" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.8');" href="#"><i id="ch9ex8" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_8/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_9/' class="p-2">Exercise 9 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex9');" href="#"><i id="ch9ex9" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.9');" href="#"><i id="ch9ex9" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_9/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_10/' class="p-2">Exercise 10 (csp-clause-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex10');" href="#"><i id="ch9ex10" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.10');" href="#"><i id="ch9ex10" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_10/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_11/' class="p-2">Exercise 11 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex11');" href="#"><i id="ch9ex11" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.11');" href="#"><i id="ch9ex11" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_11/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_12/' class="p-2">Exercise 12 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex12');" href="#"><i id="ch9ex12" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.12');" href="#"><i id="ch9ex12" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_12/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_13/' class="p-2">Exercise 13 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex13');" href="#"><i id="ch9ex13" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.13');" href="#"><i id="ch9ex13" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_13/question.md %}</p>
    </div>
</div>

<br>


<div class="card">
    <div class="card-header p-2">
        <a href='ex_14/' class="p-2">Exercise 14 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex14');" href="#"><i id="ch9ex14" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.14');" href="#"><i id="ch9ex14" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_14/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_15/' class="p-2">Exercise 15 (standardize-failure-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex15');" href="#"><i id="ch9ex15" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.15');" href="#"><i id="ch9ex15" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_15/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_16/' class="p-2">Exercise 16 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex16');" href="#"><i id="ch9ex16" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.16');" href="#"><i id="ch9ex16" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_16/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_17/' class="p-2">Exercise 17 (bc-trace-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex17');" href="#"><i id="ch9ex17" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.17');" href="#"><i id="ch9ex17" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_17/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_18/' class="p-2">Exercise 18 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex18');" href="#"><i id="ch9ex18" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.18');" href="#"><i id="ch9ex18" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_18/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_19/' class="p-2">Exercise 19 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex19');" href="#"><i id="ch9ex19" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.19');" href="#"><i id="ch9ex19" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_19/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_20/' class="p-2">Exercise 20 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex20');" href="#"><i id="ch9ex20" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.20');" href="#"><i id="ch9ex20" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_20/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_21/' class="p-2">Exercise 21 (diff-simplify-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex21');" href="#"><i id="ch9ex21" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.21');" href="#"><i id="ch9ex21" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_21/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_22/' class="p-2">Exercise 22 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex22');" href="#"><i id="ch9ex22" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.22');" href="#"><i id="ch9ex22" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_22/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_23/' class="p-2">Exercise 23 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex23');" href="#"><i id="ch9ex23" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.23');" href="#"><i id="ch9ex23" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_23/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_24/' class="p-2">Exercise 24 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex24');" href="#"><i id="ch9ex24" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.24');" href="#"><i id="ch9ex24" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_24/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_25/' class="p-2">Exercise 25 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex25');" href="#"><i id="ch9ex25" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.25');" href="#"><i id="ch9ex25" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_25/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_26/' class="p-2">Exercise 26 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex26');" href="#"><i id="ch9ex26" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.26');" href="#"><i id="ch9ex26" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_26/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_27/' class="p-2">Exercise 27 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex27');" href="#"><i id="ch9ex27" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.27');" href="#"><i id="ch9ex27" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_27/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_28/' class="p-2">Exercise 28 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex28');" href="#"><i id="ch9ex28" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.28');" href="#"><i id="ch9ex28" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_28/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_29/' class="p-2">Exercise 29 (quantifier-order-exercise) </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex29');" href="#"><i id="ch9ex29" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.29');" href="#"><i id="ch9ex29" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_29/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_30/' class="p-2">Exercise 30 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex30');" href="#"><i id="ch9ex30" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.30');" href="#"><i id="ch9ex30" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_30/question.md %}</p>
    </div>
</div>

<br>

<div class="card">
    <div class="card-header p-2">
        <a href='ex_31/' class="p-2">Exercise 31 </a>
        <button type="button" class="btn btn-dark float-right" title="Bookmark exercise" onclick="bookmark('ch9ex31');" href="#"><i id="ch9ex31" class="fas fa-bookmark" style="color:white"></i></button>
        <button type="button" class="btn btn-dark float-right" style="margin-left:10px; margin-right:10px;" title="Upvote Exercise" onclick="upvote('ex9.31');" href="#"><i id="ch9ex31" class="fas fa-thumbs-up" style="color:white"></i></button>
    </div>
    <div class="card-body">
        <p class="card-text">{% include_relative exercises/ex_31/question.md %}</p>
    </div>
</div>

<br>
